--------------------------------------------------------------------------------
-- Code developed by Generis Technology Limited
--
-- Product Name: B-Smart
--
-- Component Name: Meter Asset Manager
--
-- Description: Script to apply MDD change 11/200
--
-- Parameters : 1 - Home directory of the B-Smart installation (typically $MDB_HOME)
--
-- Amendment History:                   Date        Author            Vers
-- ------------------                   ---------   -------           -----
-- B-Smart Initial Release             15/02/2011  M Davenport       9.0.002.0
--------------------------------------------------------------------------------
--
-- SET SERVEROUTPUT ON SIZE 1000000
SET VERIFY OFF
--
PROMPT
PROMPT Script to apply MDD change 11/200
PROMPT
PROMPT Version 9.0.002.0
PROMPT
--
-- DEFINE mdb_home = &1
--
PROMPT
PROMPT Add OPL, Opus Energy Limited as SHIP. (MDD 11/200)
PROMPT
--
SET SCAN OFF
--
DECLARE
  invalid_column      EXCEPTION;
  is_snapshot         EXCEPTION;
  row_exists          EXCEPTION;
  PRAGMA EXCEPTION_INIT(invalid_column, -904);
  PRAGMA EXCEPTION_INIT(is_snapshot, -1732);
  PRAGMA EXCEPTION_INIT(row_exists, -1);
  L_MP_CODE           VARCHAR2(100);
  L_MP_ROLE           VARCHAR2(100);
  L_APPLY_CODE        VARCHAR2(1);



  CURSOR C_MP_CODE IS
    SELECT PARAM_VALUE
      FROM PROGRAM_PARAMETERS
     WHERE PARAM_NAME = 'DEFAULT_MARKET_PARTICIPANT_CODE';



  CURSOR C_MP_ROLE IS
    SELECT PARAM_VALUE
      FROM PROGRAM_PARAMETERS
     WHERE PARAM_NAME = 'SYSTEMOWNER_ROLE';




BEGIN


  OPEN C_MP_CODE;
  FETCH C_MP_CODE INTO L_MP_CODE;
  IF C_MP_CODE%NOTFOUND
  THEN
    L_MP_CODE := 'GENERIS';
  END IF;
  CLOSE C_MP_CODE;

  OPEN C_MP_ROLE;
  FETCH C_MP_ROLE INTO L_MP_ROLE;
  IF C_MP_ROLE%NOTFOUND
  THEN
    L_MP_ROLE := 'SUP';
  END IF;
  CLOSE C_MP_ROLE;

  L_APPLY_CODE :='Y';

  IF L_MP_CODE = 'BGT' AND L_MP_ROLE <> 'MAM'
     THEN L_APPLY_CODE := 'N';
  END IF;


  IF L_APPLY_CODE = 'Y' THEN  
  
  EXECUTE IMMEDIATE 'INSERT INTO ADDRESS (ADDRESS_ID,BUILDING_NUMBER,BUILDING_NAME,BUILDING_NAME_SUB,
                       ADDRESS_1,ADDRESS_2,ADDRESS_3,ADDRESS_4,POSTCODE_OUTCODE,POSTCODE_INCODE,
                       CREATED_USER_ID,CREATED_MARKET_PARTICIPANT,CREATED_DATE)
                       VALUES (ADDRESS_ID_SEQ.NEXTVAL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,''X9'',''9XX'',
                       USER,''BSMART'',SYSDATE)';

    EXECUTE IMMEDIATE 'INSERT INTO MARKET_PARTICIPANT (MARKET_PARTICIPANT_CODE,MARKET_PARTICIPANT_NAME,
                       CREATED_USER_ID,CREATED_DATE,MARKET_PARTICIPANT_ABBR_NAME)
                       VALUES (''OPL'',''Opus Energy Limited'',USER,SYSDATE,''OPL'')';

    EXECUTE IMMEDIATE 'INSERT INTO MARKET_PARTICIPANT_IN_ROLE (MARKET_PARTICIPANT_CODE,MARKET_PARTICIPANT_ROLE_CODE,
                       EFFECTIVE_FROM_DATE,EFFECTIVE_TO_DATE,MARKET_PARTICIPANT_ROLE_NAME,ADDRESS_ID,
                       REGISTRATION_NUMBER,REGISTRATION_BODY,MARKET_PARTICIPANT_ROLE_ID,
                       MARKET_PARTICIPANT_ROLE_PORT,CREATED_USER_ID,CREATED_DATE)
                       VALUES (''OPL'',''SHIP'',TO_DATE(''01011900000000'',''DDMMYYYYHH24MISS''),NULL,
                       ''Opus Energy Limited (SHIP)'',ADDRESS_ID_SEQ.CURRVAL,NULL,NULL,NULL,NULL,USER,SYSDATE)';
               END IF;
EXCEPTION
  WHEN is_snapshot OR invalid_column OR row_exists THEN
    NULL;
END;
/
SET SCAN ON
--
COMMIT
/
--
SET VERIFY ON
--
